VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "WordExporter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private app_ As API_WordWrapper
Private out_ As Word.Document
Private source_ As Visio.Page

Public Function Init(sLocalTemplates$) As Boolean
  Init = False
  
  Set app_ = New API_WordWrapper
  Dim sTemplate$: sTemplate = GetTemplate(WD_TEMPLATE_NAME, sLocalTemplates)
  If sTemplate = vbNullString Then
    Call UserInteraction.ShowMessage(EM_WORD_MISSING_TEMPLATE)
    Exit Function
  End If
  Set out_ = app_.NewDocument(sTemplate)
  If out_ Is Nothing Then _
    Exit Function
  
  Init = True
End Function

Public Function Export(iSource As Visio.Page, iOrder As Collection)
  Set source_ = iSource
  Call app_.PauseUI

  Dim shapeID As Variant
  Dim aShape As Visio.Shape
  For Each shapeID In iOrder
    Set aShape = source_.Shapes.ItemFromID(CLng(shapeID))
    If aShape.MasterShape.Name = SHAPE_SCHEMA Then _
      Call ExportSchema(aShape)
    Call CSE_ProgressBar.IncrementA
  Next shapeID
  Call out_.TablesOfContents(1).Update
  
  Call app_.ResumeUI
End Function

' ========
Private Function ExportSchema(target As Visio.Shape)
  Dim textPos As Word.Range
  Set textPos = WordAddLine(VBA.Trim(target.Text), out_.Content, WB_STYLE_SCHEMA)
  
  Dim nCount&: nCount = UBound(target.ContainerProperties.GetListMembers) + 1
  If nCount = 0 Then _
    Exit Function
    
  Dim memberID As Variant
  Dim bFirst As Boolean: bFirst = True
  Dim aShape As Visio.Shape
  For Each memberID In target.ContainerProperties.GetListMembers
    Set aShape = source_.Shapes.ItemFromID(memberID)
    Set textPos = WordAddLine(VBA.Trim(aShape.Text), textPos, ElementStyle(aShape))
    If Not bFirst Then _
      Set textPos = WordAddLine(vbNullString, textPos, WB_STYLE_TEXT)
    bFirst = False
  Next memberID
End Function

Private Function ElementStyle(target As Visio.Shape) As String
  If Not target.CellExistsU(CELLSU_ELEMENT_TYPE, visExistsAnywhere) Then _
    ElementStyle = WB_STYLE_TEXT
  
  Select Case (target.CellsU(CELLSU_ELEMENT_TYPE))
    Case T_SE_BASIC: ElementStyle = WB_STYLE_TEXT
    Case T_SE_DERIVED: ElementStyle = WB_STYLE_TEXT
    Case T_SE_ASSERTION: ElementStyle = WB_STYLE_TEXT
    Case T_SE_COMMENT: ElementStyle = WB_STYLE_COMMENT
    Case T_SE_INTERPRETATION: ElementStyle = WB_STYLE_INTERPRETATION
    Case Else: ElementStyle = WB_STYLE_TEXT
  End Select
End Function
